import React,{useState,useEffect} from 'react';
import ReactDOM from 'react-dom';
import { json,scaleLinear,max,min,scaleTime,timeParse } from 'd3';
const width = 960;
const height = 500;
const App = () => {
  const [data,setData] = useState(null);
  const parseTime=timeParse("%d-%m-%Y");
  
  useEffect(()=>{
  	json("timeperiodv2.json").then(data =>{
      data.response.docs.map(d =>{
        d.start_date = parseTime(d.start_date);
        d.end_date = parseTime(d.end_date);
    });
      
    setData(data.response.docs);
      
  });
  },[]);

  if (!data) {
    return <pre>Loading...</pre>;
  }
  let listofDate =[];
  data.map(d=>{
  	listofDate.push(d.start_date);
  	listofDate.push(d.end_date);
  });
  
  const xScale = scaleTime()
    .domain([min(listofDate),max(listofDate)])
    .range([0, width])

  const yScale = scaleLinear()
    .domain([0, max(data, (d) => d.data_value)])
    .range([0, height]);
  
  
  
  
  return (
   <svg width={width} height={height}>
      {data.map((d) => (
        <rect
          fill="rgba(200,255,220,.9)"
          key={d.timeperiod}
          y={height - yScale(d.data_value)}
          x={xScale(d.start_date)}
          height={yScale(d.data_value)}
          width={xScale(d.end_date)-xScale(d.start_date)}
        />
      ))}
    </svg>
    );
};

ReactDOM.render(<App />, document.getElementById('root'));
